/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _GUI_CAVITY_HPP_
#define _GUI_CAVITY_HPP_
#include <libglademm/xml.h>
#include <gtkmm.h>
#include "module-base.hpp"
#include "ref-ptr-base.hpp"
#include "optic-cavity.hpp"
#include "gui-add-element.hpp"
#include "path-plot.hpp"

class GuiCavity : public RefPtrBase, public ModuleBase
{
public:
	GuiCavity();
	virtual ~GuiCavity();
	Gtk::Widget* get_Window();
protected:

private:
	Glib::RefPtr<Gnome::Glade::Xml> refXml; // pointer to Glade file
	OpticCavity* cavity;
	GuiAddElement* elementlist;
	PathPlot* pathplot;
	void update_drawing();
	void on_value_changed();
};

#endif // _GUI_CAVITY_HPP_
