/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _GUI_MAIN_HPP_
#define _GUI_MAIN_HPP_
#include "module-base.hpp"
#include "module-page.hpp"
#include <libglademm/xml.h>
#include <gtkmm.h>
#include <vector>
#include <algorithm>

using namespace std;

class GuiMain
{
public:
	GuiMain();
	~GuiMain();
	Gtk::Window* get_Window();
protected:

private:
	Glib::RefPtr<Gnome::Glade::Xml> refXml; // pointer to Glade file
	Gtk::Window* main_win;
	Gtk::Notebook* mainNotebook;
	void on_quit_clicked();
	void on_new_matcher();
	void on_new_opticpath();
	void on_new_cavity();
	void add_module(ModuleBase* modul, Glib::ustring name);
	void on_page_closed(ModulePage* mod);
	void remove_all_modules();
	vector <ModulePage*> tablist;
};

#endif // _GUI_MAIN_HPP_
