/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _GUI_MATCHER_HPP_
#define _GUI_MATCHER_HPP_
#include <libglademm/xml.h>
#include <gtkmm.h>
#include "module-base.hpp"
#include "ref-ptr-base.hpp"
#include "matcher.hpp"
#include "gui-add-element.hpp"
#include "path-plot.hpp"
#include "matcher-result.hpp"

class GuiMatcher: public RefPtrBase, public ModuleBase
{
public:
	GuiMatcher();
	virtual ~GuiMatcher();
	Gtk::Window* get_WindowMain();
	Gtk::Widget* get_Window();
protected:

private:
	Matcher* matcher;
	OpticPath* editlist;
	Glib::RefPtr<Gnome::Glade::Xml> refXml; // pointer to Glade file
	GuiAddElement* elementlist;
	PathPlot* pathplot;
	MatcherResult* matcherresult;
	Gtk::ProgressBar* pbar;
	void on_solve_clicked();
	void check_values();
	void update_list();
	bool on_timeout();
};

#endif // _GUI_MATCHER_HPP_
