/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "lens.hpp"
#include <iostream>

using namespace std;

Lens::Lens(double focallength)
{
	properties.add("focal length");
	properties.set("focal length",PropValue(focallength));
	properties.set("element type",PropValue("Lens",READONLY));
	properties.set("path length",PropValue(0.0,READONLY));
	update();
}
void Lens::update()
{
	double f=(properties.get("focal length")).get_double();
	matrix.set(1.0,0.0,1.0/f,1.0);
}
void Lens::print_Element()
{
	cout << "()";
}
