/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _LENS_HPP_
#define _LENS_HPP_
#include "ref-ptr.hpp"
#include "optic-element.hpp"

class Lens: public OpticElement 
{
public:
	static RefPtr<OpticElement> create(double focallength=100.0) 
	{
		return (new Lens(focallength));
	}
	virtual void print_Element();

private:
	Lens(double focallength=100.0);
	void update();
};

#endif // _LENS_HPP_
