/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _MATCHER_RESULT_HPP_
#define _MATCHER_RESULT_HPP_
#include <gtkmm.h>
#include <glibmm/i18n.h>
#include <libglademm.h>
#include "matcher.hpp"
#include "path-plot.hpp"

class MatcherResultColumns:public Gtk::TreeModel::ColumnRecord
{
public:
	MatcherResultColumns()
    { add(m_col_id); add(m_penalty); add(m_exit_z); add(m_exit_w);}

    Gtk::TreeModelColumn<guint> m_col_id;
    Gtk::TreeModelColumn<gdouble> m_penalty;
    Gtk::TreeModelColumn<gdouble> m_exit_z;
    Gtk::TreeModelColumn<gdouble> m_exit_w;
};

class MatcherResult: public Gtk::TreeView
{
public:
	MatcherResult(BaseObjectType* cobject,
                const Glib::RefPtr<Gnome::Glade::Xml>& glade_xml);
	virtual ~MatcherResult();
	void add_solution(t_MatcherSolutionList newsolutionlist);
	void plot_solution(t_MatcherSolution solution);
protected:

private:
	MatcherResultColumns m_Columns;
	Glib::RefPtr<Gtk::ListStore> m_refResultTreeModel;
	Glib::RefPtr<Gtk::TreeSelection> refTreeSelection; //reference to selection
	t_MatcherSolutionList solutionlist;
	void on_selection_changed();
	Glib::RefPtr<Gnome::Glade::Xml> refXml;
};

#endif // _MATCHER_RESULT_HPP_
