/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * lasercalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * lasercalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * lasercalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "module-page.hpp"
#include <iostream>

using namespace std;

ModulePage::ModulePage(Gtk::Notebook* mainNotebook, ModuleBase* modul, Glib::ustring name)
{
	notebook=mainNotebook;
	record.module=modul;
	record.name=name;
	// Create body
	pathwin=record.module->get_Window();
	vbox=new Gtk::VBox;
	pathwin->reparent(*vbox);
	bimage.set(Gtk::Stock::CLOSE,Gtk::ICON_SIZE_MENU);
	// Create header
	header=new Gtk::HBox;
	Gtk::Label* lab=new Gtk::Label(record.name);
	Gtk::Button* quitbutton=new Gtk::Button();
	quitbutton->set_relief(Gtk::RELIEF_NONE);
	quitbutton->add(bimage);
	quitbutton->show_all_children();
	quitbutton->signal_clicked().connect(
		sigc::mem_fun(*this, &ModulePage::on_close_clicked));
	header->pack_start(*lab);
	header->pack_start(*quitbutton);
	header->show_all_children();
}
Gtk::Widget* ModulePage::get_PageBody()
{
	return vbox;
}
Gtk::Widget* ModulePage::get_PageHeader()
{
	return header;
}
void ModulePage::on_close_clicked()
{
	close();
	signalPageClosed_.emit(this);
}
void ModulePage::close()
{
	Gtk::Widget* widget=record.module->get_Window();
	notebook->remove_page(*vbox);
	delete widget;
	delete vbox;
	delete record.module;
}
ModulePage::signal_page_closed_t& ModulePage::signalPageClosed()
{
	return signalPageClosed_;
}
