/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * lasercalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * lasercalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * lasercalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _MODULE_PAGE_HPP_
#define _MODULE_PAGE_HPP_
#include <glibmm.h>
#include <glibmm/i18n.h>
#include "module-base.hpp"

class ModulePage
{
public:
	ModulePage(Gtk::Notebook* mainNotebook, ModuleBase* modul, Glib::ustring name);
	Gtk::Widget* get_PageBody();
	Gtk::Widget* get_PageHeader();
	void close();
	typedef sigc::signal< void, ModulePage* > signal_page_closed_t;
	signal_page_closed_t& signalPageClosed();
protected:
	signal_page_closed_t signalPageClosed_; 
private:
	void on_close_clicked(); //signal handler for close button
	Gtk::Notebook* notebook;
	Gtk::VBox* vbox;
	ModuleRecord record;
	Gtk::Widget* pathwin;
	Gtk::HBox* header;
	Gtk::Image bimage; // The image of the close button
};

#endif // _MODULE_PAGE_HPP_
