/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _OPTIC_CAVITY_HPP_
#define _OPTIC_CAVITY_HPP_
#include "optic-beam.hpp"

class OpticCavity: public OpticPath 
{
public:
	OpticCavity();
	virtual ~OpticCavity();
	void set_Wavelength(gdouble newwave);
	gdouble get_Stability();
	gdouble get_Stability2(); //definition like in Pramana paper
	gdouble get_Eigen_Z();
	gdouble get_Eigen_W();
	OpticBeam get_Eigenmode();
protected:

private:
	OpticBeam beam;
	virtual void update();
};

#endif // _OPTIC_CAVITY_HPP_
