/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "optic-element.hpp"
#include <iostream>

using namespace std;

OpticElement::OpticElement()
{
	properties.add("name",PropValue(" "));
	properties.add("element type",PropValue("unknown"));
	properties.add("path length",PropValue(0.0));
}

OpticElement::~OpticElement()
{
}

void OpticElement::set_Property(string key,PropValue newprop)
{
	try
	{
		properties.set(key,newprop);
	}
	catch (propertyExcept& e)
	{
		cerr << e.what();
	}
	catch (propvalExcept& e)
	{
		cerr << e.what();
	}
	update();
}
PropValue OpticElement::get_Property(string key)
{
	return properties.get(key);
}
Properties OpticElement::get_Properties()
{
	return properties;
}
OpticMatrix OpticElement::get_Matrix()
{
	return(matrix);
}

