/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _OPTIC_ELEMENT_HPP_
#define _OPTIC_ELEMENT_HPP_
#include <string>
#include "ref-ptr-base.hpp"
#include "optic-matrix.hpp"
#include "properties.hpp"

using namespace std;

class OpticElement: public RefPtrBase
{
public:
	OpticElement();
	virtual ~OpticElement();
	void set_Property(string key,PropValue newprop);
	PropValue get_Property(string key);
	Properties get_Properties();
	OpticMatrix get_Matrix();
	virtual void print_Element()=0;

protected:
	Properties properties;
	virtual void update()=0;
	OpticMatrix matrix;
};

#endif // _OPTIC_ELEMENT_HPP_
