/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "optic-matrix.hpp"
#include <iostream>

using namespace std;

OpticMatrix::OpticMatrix(gdouble A, gdouble B, gdouble C, gdouble D)
{
	element[0][0]=A;
	element[1][0]=B;
	element[0][1]=C;
	element[1][1]=D;
}
OpticMatrix::~OpticMatrix()
{
}
void OpticMatrix::set(gdouble A, gdouble B, gdouble C, gdouble D)
{
	element[0][0]=A;
	element[1][0]=B;
	element[0][1]=C;
	element[1][1]=D;
}
gdouble OpticMatrix::get_A()
{
	return element[0][0];
}
gdouble OpticMatrix::get_B()
{
	return element[1][0];
}
gdouble OpticMatrix::get_C()
{
	return element[0][1];
}
gdouble OpticMatrix::get_D()
{
	return element[1][1];
}
void OpticMatrix::mult(OpticMatrix A)
{
	gdouble Celement[2][2];
	Celement[0][0]=A.element[0][0]*element[0][0]+A.element[1][0]*element[0][1];
	Celement[1][0]=A.element[0][0]*element[1][0]+A.element[1][0]*element[1][1];
	Celement[0][1]=A.element[0][1]*element[0][0]+A.element[1][1]*element[0][1];
	Celement[1][1]=A.element[0][1]*element[1][0]+A.element[1][1]*element[1][1];
	element[0][0]=Celement[0][0];
    element[1][0]=Celement[1][0];
	element[0][1]=Celement[0][1];
	element[1][1]=Celement[1][1];
}
OpticMatrix OpticMatrix::mult(OpticMatrix A, OpticMatrix B)
{
	OpticMatrix C;
	C.element[0][0]=A.element[0][0]*B.element[0][0]+A.element[1][0]*B.element[0][1];
	C.element[1][0]=A.element[0][0]*B.element[1][0]+A.element[1][0]*B.element[1][1];
	C.element[0][1]=A.element[0][1]*B.element[0][0]+A.element[1][1]*B.element[0][1];
	C.element[1][1]=A.element[0][1]*B.element[1][0]+A.element[1][1]*B.element[1][1];
	return(C);
}
void OpticMatrix::print()
{
	printf("/%8.3f %8.3f\\\n",element[0][0],element[1][0]);
	printf("\\%8.3f %8.3f/\n",element[0][1],element[1][1]);
}
