/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _OPTIC_MATRIX_HPP_
#define _OPTIC_MATRIX_HPP_
#include <glibmm.h>

using namespace std;

class OpticMatrix
{
public:
	OpticMatrix(gdouble A=1.0, gdouble B=0.0, gdouble C=0.0, gdouble D=1.0);
	~OpticMatrix();
	
	void set(gdouble A, gdouble B, gdouble C, gdouble D);
	gdouble get_A();
	gdouble get_B();
	gdouble get_C();
	gdouble get_D();
		
	void mult(OpticMatrix A);
	OpticMatrix mult(OpticMatrix A, OpticMatrix B);
		
	void print();

private:
	gdouble element[2][2];
};

#endif // _OPTIC_MATRIX_HPP_
