/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _OPTIC_PATH_HPP_
#define _OPTIC_PATH_HPP_
#include <vector>
#include <glibmm.h>
#include <glibmm/i18n.h>
#include "ref-ptr.hpp"
#include "ref-ptr-base.hpp"
#include "optic-element.hpp"
#include "optic-matrix.hpp"

using namespace std;
typedef vector<RefPtr<OpticElement> >::iterator i_path;

class OpticPath: public RefPtrBase
{
public:
	OpticPath();
	virtual ~OpticPath();
	void add(RefPtr<OpticElement> newelement);
	void add(guint elementnr, RefPtr<OpticElement> newelement);
	void remove();
	void remove(guint elementnr);
	guint const size(); // return # of elements
	OpticMatrix get_Matrix();
	RefPtr<OpticElement> get_Element(guint elementnr);
	Properties get_Properties(guint elementnr);
	gdouble get_PathLength();
	void set_Property (guint elementnr, string key, PropValue newprop);
	void print_Path();

protected:
	virtual void update();
	vector<RefPtr<OpticElement> > path;
	OpticMatrix pathmatrix;
};

#endif // _OPTIC_PATH_HPP_
