/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _PATH_PLOT_HPP_
#define _PATH_PLOT_HPP_
#include <gtkmm.h>
#include <libglademm.h>
#include "ref-ptr.hpp"
#include "optic-path.hpp"
#include "optic-beam.hpp"
#include "plot-data.hpp"
#include "properties.hpp"

using namespace std;

class PathPlot:public Gtk::DrawingArea
{
public:
	PathPlot(BaseObjectType* cobject,
			 const Glib::RefPtr<Gnome::Glade::Xml>& glade_xml);
	virtual ~PathPlot();
	void set_Input(OpticBeam newinput);
	//void set_Input(RefPtr<OpticBeam> newinput);
	void display(OpticPath path); // display new optic path

protected:

private:
	OpticBeam input;
	OpticPath path;
	PlotData data;
	Gtk::Label* xlabel;
	Gtk::Label* ylabel;
	//Override default signal handler:
  	virtual bool on_expose_event(GdkEventExpose* event);
	virtual bool on_motion_notify_event(GdkEventMotion* event);
	// returns beam radius at the given position of the OpticPath
	gdouble get_path_radius(gdouble position); 
	
	void path_to_data(guint nr_of_points);
	void plot_elements(guint width,guint height,
			Cairo::RefPtr<Cairo::Context> cr,Glib::RefPtr<Pango::Layout> pangoLayout);
};

#endif // _PATH_PLOT_HPP_
