/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "permutation.hpp"
#include <iostream>
#include <algorithm>
#include <stdexcept>

using namespace std;

Permutation::Permutation(gint places,gint elements)
{
	if ((places<=0) || (elements<0)) 
		throw out_of_range("Permutation(gint places, gint elements):Argument out of range");
	maxelement=elements;
	nr_of_places=places;
	for (guint i=0; i<nr_of_places; i++)
		perm.push_back(-1);
	gen(0);
}
Permutation::~Permutation()
{
}
t_permlist Permutation::get()
{
	return permlist;
}
void Permutation::gen(guint iElement)
{
	for (guint i=0; i<maxelement; i++)
	{
		if (!inlist(i))
		{
			perm[iElement]=i;
			if (iElement<nr_of_places-1)
			{
				gen(iElement+1);
			}
			else
			{
				permlist.push_back(perm);
			}
			perm[iElement]=-1;
		}
	}
}
bool Permutation::inlist(guint element)
{
	typedef t_perm::iterator iter;
	iter i=find(perm.begin(),perm.end(),element);
	if (i!=perm.end())
		return true;
	else
		return false;
}
void Permutation::print_perm(t_perm list)
{
	for(unsigned i=0; i<list.size(); i++)
		cout << list[i];
	cout << endl;
}
void Permutation::print()
{
	for (guint i=0; i<permlist.size(); i++)
		print_perm(permlist[i]);
}
