/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _PERMUTATION_HPP_
#define _PERMUTATION_HPP_
#include <vector>
#include <glibmm.h>

using namespace std;

typedef vector<gint> t_perm;
typedef vector<t_perm> t_permlist;

class Permutation
{
public:
	Permutation(gint places,gint elements);
	~Permutation();
	t_permlist get();
	void print();

private:
	t_perm perm;
	t_permlist permlist;
	int index;
	guint maxelement;
	guint nr_of_places;
	void gen(guint currentplace);
	bool inlist(guint element);
	void print_perm(t_perm currentperm);
};

#endif // _PERMUTATION_HPP_
