/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "plot-data.hpp"

PlotData::PlotData()
{
	min_x=0.0; min_y=0.0; max_x=0.0; max_y=0.0;
}
PlotData::~PlotData()
{
}
void PlotData::add(PlotData newdata)
{
	data=newdata.data;
	update_extrema();
}
void PlotData::add(t_pointset newset)
{
	data=newset;
	update_extrema();
}
t_datapoint PlotData::get(guint index)
{
	return data.at(index);
}
double PlotData::get_MaxX()
{
	return max_x;
}
double PlotData::get_MinX()
{
	return min_x;
}
double PlotData::get_MaxY()
{
	return max_y;
}
double PlotData::get_MinY()
{
	return min_y;
}
guint PlotData::size()
{
	return data.size();
}
void PlotData::update_extrema()
{
	if (data.size()!=0)
	{
		min_x=data[0].x; min_y=data[0].y; max_x=data[0].x; max_y=data[0].y;
		for (guint i=0; i<data.size(); i++)
		{
			if (data[i].x<min_x) min_x=data[i].x;
			if (data[i].x>max_x) max_x=data[i].x;
			if (data[i].y<min_y) min_y=data[i].y;
			if (data[i].y>max_y) max_y=data[i].y;
		}
	}
	else
	{
		min_x=0.0; min_y=0.0; max_x=0.0; max_y=0.0;
	}
}
