/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _PLOT_DATA_HPP_
#define _PLOT_DATA_HPP_
#include <glibmm.h>
#include <vector>

using namespace std;

typedef struct
{
	gdouble x;
	gdouble y;
} t_datapoint;

typedef vector<t_datapoint> t_pointset;

class PlotData
{
public:
	PlotData();
	~PlotData();
		
	void add(PlotData newdata);
	void add(t_pointset newset);
		
	t_datapoint get(guint index);

	gdouble get_MaxX();
	gdouble get_MinX();
	gdouble get_MaxY();
	gdouble get_MinY();
	guint size();
	
protected:

private:
	t_pointset data;
	double max_x;
	double max_y;
	double min_x;
	double min_y;
	void update_extrema();
};

#endif // _PLOT_DATA_HPP_
