/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * treeview
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * treeview is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * treeview is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "prop-renderer-numeric.hpp"
#include <sstream>
#include <iostream>

PropRendererNumeric::PropRendererNumeric() :
	Glib::ObjectBase( typeid(PropRendererNumeric) ),
	Gtk::CellRendererSpin()
{
	adjust=Gtk::manage(new Gtk::Adjustment(0,-10000,10000));
	property_adjustment()=adjust;
}
PropRendererNumeric::~PropRendererNumeric()
{
}
void PropRendererNumeric::set_value(PropValue value)
{
	stringstream ss;
	if (value.get_type()==INT) 
	{
		ss << value.get_int();
		property_text()=ss.str();
		property_digits().set_value(1);
		adjust->set_step_increment(1);
	} else
	if (value.get_type()==DOUBLE)
	{
		ss << value.get_double();
		property_text()=ss.str();
		property_digits().set_value(5);
		adjust->set_step_increment(0.1);
		
	}
	property_adjustment()=adjust;
	property_editable()=!value.readonly();
	property_sensitive()=!value.readonly();
}
void PropRendererNumeric::on_edited (const Glib::ustring& path, const Glib::ustring& new_text)
{
	PropValue prop(new_text);
	signalPropvalChanged_.emit(path,prop);
}

PropRendererNumeric::signal_propval_changed_t& PropRendererNumeric::signalPropvalChanged()
{
	return signalPropvalChanged_;
}
