/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * treeview
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * treeview is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * treeview is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "prop-renderer-text.hpp"
#include <iostream>
PropRendererText::PropRendererText() :
	Glib::ObjectBase( typeid(PropRendererText) ),
	Gtk::CellRendererText()
{
}
PropRendererText::~PropRendererText()
{
}
void PropRendererText::set_value(PropValue value)
{
	property_text()=value.get_string();
	property_editable()=!(value.readonly());
	property_sensitive()=!(value.readonly());
}
void PropRendererText::on_edited(const Glib::ustring &path,const Glib::ustring &new_text)
{
	PropValue prop=PropValue(new_text);
	signalPropvalChanged_.emit(path,prop);
}
PropRendererText::signal_propval_changed_t& PropRendererText::signalPropvalChanged()
{
	return signalPropvalChanged_;
}
