/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * lasercalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * lasercalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * lasercalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _PROP_RENDERER_TEXT_HPP_
#define _PROP_RENDERER_TEXT_HPP_
#include <gtkmm.h>
#include "prop-value.hpp"

// This cell renderer renders the STRING version of a PropValue
class PropRendererText: public Gtk::CellRendererText 
{
public:
	PropRendererText();
	~PropRendererText();
	void set_value(PropValue value);
	typedef sigc::signal< void, const Glib::ustring &, PropValue& > signal_propval_changed_t;
	signal_propval_changed_t& signalPropvalChanged();
protected:
	signal_propval_changed_t signalPropvalChanged_;
	virtual void on_edited(const Glib::ustring &path,const Glib::ustring &new_text);
};

#endif // _PROP_RENDERER_TEXT_HPP_
