/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * lasercalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * lasercalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * lasercalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _PROP_TREE_HPP_
#define _PROP_TREE_HPP_
#include <gtkmm.h>
#include <glibmm/i18n.h>
#include "properties.hpp"
#include "prop-value.hpp"
#include "prop-renderer.hpp"

using namespace std;

//Tree model columns:
class PropTree
{
public:
	PropTree(Gtk::TreeView* treeview);
	~PropTree();
	void set(Properties prop);
	void clear(); // clear the proptree list
	class ModelColumns : public Gtk::TreeModel::ColumnRecord
	{
	public:
		ModelColumns()
		{ add(col_prop); add(col_value);}
		Gtk::TreeModelColumn<Glib::ustring> col_prop;
		Gtk::TreeModelColumn<PropValue> col_value;
	};
	typedef sigc::signal< void, Properties& > signal_prop_changed_t;
	signal_prop_changed_t& signalPropertiesChanged();
protected:
	signal_prop_changed_t signalPropertiesChanged_; 
private:
	ModelColumns columns;
	Glib::RefPtr<Gtk::ListStore> refTreeModel;
	void Router_value_onEdited(const Glib::ustring path,PropValue value);
};
#endif // _PROP_TREE_HPP_
