/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _PROP_VALUE_HPP_
#define _PROP_VALUE_HPP_
#include <glibmm.h>
#include <glibmm/i18n.h>

const bool READONLY=true;

using namespace std;

enum Valtype {NONE,INT,DOUBLE,STRING,BOOL};

class propvalExcept
{
	Glib::ustring text;
public:
	propvalExcept(Glib::ustring s):text(s){}
		virtual const Glib::ustring what()
	{
		Glib::ustring out = Glib::ustring::compose("\nError! PropValue::%1\n",
                                    text);

		return (out);
	}
};

class PropValue
{
public:
	PropValue();
	PropValue(int newint, bool ronly=false);
	PropValue(double newdouble, bool ronly=false);
	PropValue(Glib::ustring newstring, bool ronly=false);
	~PropValue();
	void set(PropValue newprop);
	void set(int newint);
	void set(double newdouble);
	void set(Glib::ustring newstring);
	void set_readonly ();
	int get_int();
	double get_double();
	Glib::ustring get_string();
	Valtype get_type();
	bool readonly();
	void print();
	// overload default copy operator in order to honor the READONLY status
	//PropValue& operator= (PropValue& pval);
private:
	Valtype valtype;
	bool is_readonly;
	int intval;
	double doubleval;
	Glib::ustring stringval;
};

#endif // _PROP_VALUE_HPP_
