/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _PROPERTIES_HPP_
#define _PROPERTIES_HPP_
#include <glibmm.h>
#include <glibmm/i18n.h>
#include <string>
#include <map>
#include "prop-value.hpp"

using namespace std;

class propertyExcept
{
	Glib::ustring text;
public:
	propertyExcept(Glib::ustring s):text(s){}
		virtual const Glib::ustring what()
	{
		Glib::ustring out = Glib::ustring::compose("\nError! Properties::%1\n",
                                    text);

		return (out);
	}
};
//Notice: Don't use Glib::ustring as key. It is too slow.
typedef map<string,PropValue>::iterator PropIter;
class Properties
{
public:
	void add(string key,PropValue value=PropValue());
	void set(string key,PropValue newprop);
	PropValue get(string key);	
	Valtype get_type(string key);
	gint size();
	void print();
	PropIter begin();
	PropIter end();
	typedef sigc::signal< void, string&,PropValue& > signal_changed_t;
	signal_changed_t& signalChanged();
protected:
	signal_changed_t signalChanged_;
private:
		map <string,PropValue> properties;	
};

#endif // _PROPERTIES_HPP_
