/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * LaserCalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * LaserCalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * LaserCalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _RANDOM_GEN_HPP_
#define _RANDOM_GEN_HPP_
#include <glibmm.h>
/** This class delivers random numbers.
 	It uses the rand function from the standard C library.
 */
class RandomGen
{
public:
	/** Initializes the random generator.
		 For the seed value the system time is used
	*/
	RandomGen(void); // Init
	gdouble get(); // random number between [0,1[
	/** returns a random number between [0,max[
		\param max the maximum random value to be returned
	*/
	gdouble get(gdouble max); // random number between [0,max[
	/** returns a random number symmetrically around zero between ]-max,max[
		\param max the maximum interval
	*/
	gdouble get_sym(gdouble max); // random number between ]-max,max[
};

#endif // _RANDOM_GEN_HPP_
