/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * lasercalc
 * Copyright (C) Udo Eisenbarth 2008 <udo.eisenbarth@web.de>
 * 
 * lasercalc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * lasercalc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "util.hpp"
#include "config.h"
#include <iostream>

#define GLADE_FILE_FULL_PATH PACKAGE_DATA_DIR "/" PACKAGE "/glade"

using namespace std;

Glib::RefPtr<Gnome::Glade::Xml> load_glade_xml(std::string glade_name)
{
	Glib::RefPtr<Gnome::Glade::Xml> refXml;
	string path;
	path=Glib::build_filename(GLADE_FILE_FULL_PATH,glade_name);
	if (Glib::file_test(glade_name,Glib::FILE_TEST_EXISTS))
	{
		refXml = Gnome::Glade::Xml::create(glade_name);
	}
	else if (Glib::file_test(path,Glib::FILE_TEST_EXISTS))
	{
		refXml = Gnome::Glade::Xml::create(path);
	}
	else
	{
		cout << "Glade file not found" << endl;
	}
	return refXml;
}

